Unit Help;
{========================================================================}
Interface
  Procedure ListHelp;
  Procedure AreaHelp;
  Procedure CommandHelp;
{========================================================================}
Implementation
  Uses
    Crt, MfmDefs, Screen, Setup;
{========================================================================}
Procedure ListHelp;
  Begin
    AnsiClearScreen; NewTextColor(7);
    AnsiGotoXY(40-(Length(Pgmid) Div 2),1); MfmWriteLn(Pgmid);
    MfmWriteLn('[Navagate through list]ͻ');
    MfmWrite('');
    NewTextColor(LightBlue);
    MfmWrite('          7 : TopOfList       8 : LineUp             9 : PageUp             ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWrite('');
    NewTextColor(LightBlue);
    MfmWrite('          1 : BottomOfList    2 : LineDown           3 : PageDown           ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWriteLn('[Add, Edit and Rename]͹');
    MfmWrite('');
    NewTextColor(LightGreen);
    MfmWrite(' A : Adopt/Abandon         E : Edit Description        I : Insert Blank     ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWrite('');
    NewTextColor(LightGreen);
    MfmWrite(' R : Rename File           D : Change File Date       ^A : Adopt ALL        ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWriteLn('[Copy or Move between areas]͹');
    MfmWrite('');
    NewTextColor(LightCyan);
    MfmWrite(' C : Copy to New Area      M : Move to New Area                             ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWrite('');
    NewTextColor(LightCyan);
    MfmWrite(' $ : Mass Copy             # : Mass Move          <SP> : Toggle Tag         ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWriteLn('[Move or Remove entries in list]͹');
    MfmWrite('');
    NewTextColor(LightRed);
    MfmWrite(' < : Push Record     > : Pop Record   K : Kill Entry      U : UnKill Entry  ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWrite('');
    NewTextColor(LightRed);
    MfmWrite(' [ : Stack Prev      ] : Stack Next   { : Prev Kill       } : Next Kill     ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWrite('');
    NewTextColor(LightRed);
    MfmWrite(' ; : Show Stack                       : : Show Kill                         ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWriteLn('[Sort list]͹');
    MfmWrite('');
    NewTextColor(LightMagenta);
    MfmWrite(' F : Mark First           L : Mark Last               S : Sort              ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWriteLn('[Search for string]͹');
    MfmWrite('');
    NewTextColor(Yellow);
    MfmWrite(' ^F : In File Name       ^D : In Description         ^B : In Both           ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWriteLn('[View]͹');
    MfmWrite('');
    NewTextColor(LightBlue);
    MfmWrite(' ALT-V : Auto File View                 ALT-L : Use Default Viewer          ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWrite('');
    NewTextColor(LightBlue);
    MfmWrite(' ALT-Z : Use Picture File Viewer        ALT-F : Use Compressed File Viewer  ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWriteLn('[Misc]͹');
    MfmWrite('');
    NewTextColor(LightGreen);
    MfmWrite(' N : New Area   W : Write List   ! : ReDraw Screen    ALT-S : Shell to DOS  ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWrite('');
    NewTextColor(LightGreen);
    MfmWrite(' Z : Display directory of compressed file                  ^R : Debit user  ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWrite('ͼ');
    AnsiGotoXY(25,25);
    MfmWrite('[ ');
    NewTextColor(Blink+Red);
    MfmWrite('Press any key to continue!');
    NewTextColor(LightGray);
    MfmWrite(' ]');
    NewTextColor(White);
    AnsiGotoXY(80,1);
    Gbx := GetInput;
    ReDrawScreen;
  End;
{========================================================================}
Procedure AreaHelp;
  Begin
    AnsiClearScreen;
    NewTextColor(White);
    AnsiGotoXY(40-(Length(Pgmid) Div 2),1);
    MfmWriteLn(Pgmid);
    NewTextColor(LightGray);
    MfmWriteLn('[Navagate through list]ͻ');
    MfmWrite('');
    NewTextColor(LightGreen);
    MfmWrite('          7 : TopOfList        8 : LineUp            9 : PageUp             ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWrite('');
    NewTextColor(LightGreen);
    MfmWrite('          1 : BottomOfList     2 : LineDown          3 : PageDown           ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWriteLn('[Match Mask]͹');
    MfmWrite('');
    NewTextColor(LightRed);
    MfmWrite('                Use letter keys to spell area description                   ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWriteLn('[Misc]͹');
    MfmWrite('');
    NewTextColor(LightBlue);
    MfmWrite('    ENTER : Select Area   ESC : Quit with prompt   ^Q : Quit immediately    ');
    NewTextColor(LightGray);
    MfmWriteLn('');
    MfmWrite('ͼ');
    AnsiGotoXY(27,25);
    NewTextColor(Blink+LightRed);
    MfmWrite('Press any key to continue!');
    NewTextColor(White);
    AnsiGotoXY(80,1);
    Gbx := GetInput;
  End;
{========================================================================}
Procedure CommandHelp;
  Begin
    MfmWriteLn(Pgmid);
    MfmWriteLn('');
    MfmWriteLn('The following command line options are valid.');
    MfmWriteLn('');
    MfmWriteLn('        A - Directory for Maximus area file.  ( /AC:\MAX )');
    MfmWriteLn('        C - Port re-direction.  0 = Console');
    MfmWriteLn('                                1 = Com1');
    MfmWriteLn('                                2 = Com2');
    MfmWriteLn('                                9 = Standard I/O');
    MfmWriteLn('        D - Select area by directory.');
    MfmWriteLn('        P - Directory to start MFM in.');
    MfmWriteLn('        T - Disable TAB in area selection.');
    MfmWriteLn('');
    Halt(0);
  End;
{========================================================================}
Begin
End.
{========================================================================}
